/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

import java.awt.*;

public class Blocklampe extends Lampe {
	public static final int LINKS = 1;
	public static final int RECHTS = 2;
	
	public Blocklampe (Container par, int x, int y, Color farbe, int ausrichtung) {
		super (par, x, y, farbe);
		
		richtung = ausrichtung;
	}
	
	@Override
	public void paint (Graphics g) {
		if (g == null) return;
		if (ein) g.setColor (c);
		else g.setColor (Color.DARK_GRAY);
		if (richtung == RECHTS) {
			g.drawLine (p.x - 8, p.y - 4, p.x + 2, p.y - 4);
			g.drawLine (p.x - 8, p.y - 3, p.x + 4, p.y - 3);
			g.drawLine (p.x - 8, p.y - 2, p.x + 6, p.y - 2);
			g.drawLine (p.x - 8, p.y - 1, p.x + 8, p.y - 1);
			g.drawLine (p.x - 8, p.y, p.x + 8, p.y);
			g.drawLine (p.x - 8, p.y + 1, p.x + 6, p.y + 1);
			g.drawLine (p.x - 8, p.y + 2, p.x + 4, p.y + 2);
			g.drawLine (p.x - 8, p.y + 3, p.x + 2, p.y + 3);
		} else {
			g.drawLine (p.x - 2, p.y - 4, p.x + 8, p.y - 4);
			g.drawLine (p.x - 4, p.y - 3, p.x + 8, p.y - 3);
			g.drawLine (p.x - 6, p.y - 2, p.x + 8, p.y - 2);
			g.drawLine (p.x - 8, p.y - 1, p.x + 8, p.y - 1);
			g.drawLine (p.x - 8, p.y, p.x + 8, p.y);
			g.drawLine (p.x - 6, p.y + 1, p.x + 8, p.y + 1);
			g.drawLine (p.x - 4, p.y + 2, p.x + 8, p.y + 2);
			g.drawLine (p.x - 2, p.y + 3, p.x + 8, p.y + 3);
		}
	}
	
	int richtung;
}
