/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

public class Fahrstrasse {
	public Fahrstrasse (int id) {
		nr = id;
		war_belegt = new boolean[8];
	}
	
	public boolean fsSperren (boolean ausfuehren) {
		if (eingestellt) return false;
		if (!ausfuehren) return true;
		gesperrt++;
		return true;
	}
	
	public void fsFreigeben () {
		if (gesperrt <= 0) System.out.println ("Fahrstrassenfreigabe: Nicht gesperrt");
		gesperrt--;
	}
	
	public boolean fsEinstellen () {
		int i;
		
		if (fs_tab[nr][20] != 0) {
			if (!FSKasten.gl_anz[fs_tab[nr][20] - 1].einfahrtOk()) return false;
		}
		
		for (i = 0; i <= 3; i++) {
			switch (fs_tab[nr][i]) {
			case 1:
				if (!wh[i].inPluslage()) return false;
				break;
			case 2:
				if (!wh[i].inMinuslage()) return false;
				break;
			}
		}
		for (i = 0; i <= 11; i++) {
			switch (fs_tab[nr][i+8]) {
			case 1:
				if (!fs[i].fsSperren(false)) return false;
			}
		}
		for (i = 0; i <= 3; i++) {
			if (fs_tab[nr][i] != 0) wh[i].weicheVerschliessen();
		}
		for (i = 0; i <= 11; i++) {
			switch (fs_tab[nr][i+8]) {
			case 1:
				if (!fs[i].fsSperren(true)) return false;
			}
		}

		eingestellt = true;
		
		if (fs_tab[nr][20] != 0) {
			FSKasten.gl_anz[fs_tab[nr][20]-1].einfahrtStellen();
		}
		if (fs_tab[nr][21] != 0) {
			FSKasten.gl_anz[fs_tab[nr][21]-1].ausfahrtStellen();
		}

		for (i = 0; i <= 3; i++) {
			switch (fs_tab[nr][i+4]) {
			case 1:
				sh[i].signalFreigeben (1, this);
				break;
			case 2:
				sh[i].signalFreigeben (2, this);
				break;
			}
		}

		return true;
	}
	
	public boolean fsAufloesen () {
		int i;

		if (festgehalten) return false;
		
		if (fs_tab[nr][21] != 0) {
			if (!FSKasten.gl_anz[fs_tab[nr][21] - 1].ausfahrtAufloesenOk()) return false;
		}

		for (i = 0; i <= 3; i++) {
			if (fs_tab[nr][i+4] != 0) {
				if (!sh[i].inPluslage()) return false;
				sh[i].signalFreigeben(0, null);
			}
		}
		
		for (i = 0; i <= 3; i++) {
			if (fs_tab[nr][i] != 0)
				wh[i].weichenverschlussAufheben();
		}
		
		// TODO: Auf Abfrage ndern
		for (i = 0; i <= 11; i++) {
			if (fs_tab[nr][i+8] != 0)
				fs[i].fsFreigeben();
		}
		
		eingestellt = false;

		if (fs_tab[nr][20] != 0) {
			FSKasten.gl_anz[fs_tab[nr][20]-1].einfahrtAufloesen();
		}

		if (fs_tab[nr][21] != 0) {
			FSKasten.gl_anz[fs_tab[nr][21]-1].ausfahrtAufloesen();
		}

		for (i = 0; i < 8; i++) war_belegt[i] = false;
		signal_halt = false;
		
		return true;
	}
	
	public void fsFesthalten(boolean f) {
		festgehalten = f;
	}

	// bool weicheVerschliessen (plus/minus)
	// void weicheOeffnen ()
	// void signalFreigeben (fahrt/fahrt2)
	// bool signalSperren ()		-> Geht nur wenn Signal auf Halt.
	// bool signalFesthalten ()	(Von Durchfahrtsignalen)
	// bool fsSperren ()
	// bool fsFreigeben ()
	
	public static int fs_tab[][] = {
	//	  1  2 34  5  A  B  C  D a2 a3 a1 b1 b2 b3 c2 c3 c1 d1 d2 d3  E  A
		{ 1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 2, 0},	// a2
		{ 2, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 1, 1, 3, 0},	// a3
		{ 1, 2, 0, 0, 2, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 1, 1, 1, 1, 0},	// a1
		{ 1, 2, 0, 0, 0, 2, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1},	// b1
		{ 1, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 2},	// b2
		{ 2, 0, 0, 0, 0, 2, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 3},	// b3
		{ 0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 2},	// c2
		{ 0, 0, 0, 2, 0, 0, 2, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 3},	// c3
		{ 0, 0, 2, 1, 0, 0, 2, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1},	// c1
		{ 0, 0, 2, 1, 0, 0, 0, 2, 1, 1, 1, 0, 1, 1, 1, 0, 0, 0, 0, 0, 1, 0},	// d1
		{ 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 0, 0, 0, 0, 2, 0},	// d2
		{ 0, 0, 0, 2, 0, 0, 0, 2, 1, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 3, 0}	// d3
	};

	public static int iso_tab_einst[][] = {
	//	 1u  1  2 1y  4 5x 5y  5
		{ 1, 1, 1, 2, 1, 1, 0, 0 },
		{ 1, 1, 2, 1, 0, 0, 1, 0 },
		{ 1, 1, 1, 2, 0, 0, 0, 0 },
		{ 1, 1, 1, 2, 0, 0, 0, 0 },
		{ 1, 1, 1, 2, 0, 0, 0, 0 },
		{ 1, 1, 2, 1, 0, 0, 0, 0 },
		{ 0, 0, 0, 0, 0, 1, 2, 1 },
		{ 0, 0, 0, 0, 0, 2, 1, 1 },
		{ 0, 0, 0, 0, 1, 1, 2, 1 },
		{ 0, 0, 0, 0, 1, 1, 2, 1 },
		{ 0, 0, 1, 0, 1, 1, 2, 1 },
		{ 0, 0, 0, 1, 0, 2, 1, 1 }
	};
	
	public static int iso_tab_halt[][] = {
	//	 1u  1  2 1y  4 5x 5y  5
		{ 3, 3, 0, 0, 0, 0, 0, 0 },
		{ 3, 3, 0, 0, 0, 0, 0, 0 },
		{ 3, 3, 0, 0, 0, 0, 0, 0 },
		{ 3, 4, 0, 0, 0, 0, 0, 0 },
		{ 3, 4, 0, 0, 0, 0, 0, 0 },
		{ 3, 4, 0, 0, 0, 0, 0, 0 },
		{ 0, 0, 0, 0, 0, 3, 0, 4 },
		{ 0, 0, 0, 0, 0, 0, 3, 4 },
		{ 0, 0, 0, 0, 0, 3, 0, 4 },
		{ 0, 0, 0, 0, 0, 3, 0, 3 },
		{ 0, 0, 0, 0, 0, 3, 0, 3 },
		{ 0, 0, 0, 0, 0, 0, 3, 3 }
	};
	
	public static boolean iso_tab_weichen[][] = {
		{  true,  true,  true,  true, false, false, false, false },
		{ false,  true,  true, false, false, false, false, false },
		{ false, false, false, false,  true, false, false, false },
		{ false, false, false, false, false,  true,  true,  true }
	};
	
	public static boolean pruefeWeichenIsolierungen(boolean iso_tab[]) {
		int i;
		boolean ok = true;
		
		for (i = 0; i < 8; i++) {
			if (iso_tab[i] && iso[i].istBelegt()) ok = false;
		}
		
		return ok;
	}
	
	public boolean pruefeIsolierungen() {
		int i;
		boolean ok = true;
		
		for (i = 0; i < 8; i++) {
			switch(iso_tab_einst[nr][i]) {
				case 1:
				case 2:
					if (iso[i].istBelegt()) ok = false;
					break;
				default:
					
			}
		}
		return ok;
	}
	
	public boolean pruefeUeberwachung() {
		int i;
		boolean ok = true;
		boolean halt = true;
		boolean kein_halt = true;
		boolean gleichzeitig_belegt = true;
		
		for (i = 0; i < 8; i++) {
			if (iso[i].istBelegt()) war_belegt[i] = true;
			switch(iso_tab_einst[nr][i]) {
				case 2:
					if (iso[i].istBelegt()) ok = false;
					break;
			}
		}
		
		for (i = 0; i < 8; i++) {
			if (iso_tab_halt[nr][i] != 0) {
				kein_halt = false;
				if (!iso[i].istBelegt()) gleichzeitig_belegt = false;
			}
			switch(iso_tab_halt[nr][i]) {
				case 3:
					if (!war_belegt[i]) halt = false;
					break;
				case 4:
					if (!war_belegt[i]) halt = false;
					if (iso[i].istBelegt()) halt = false;
					break;
			}
		}
		
		if (gleichzeitig_belegt) signal_halt = true;
		if (!signal_halt) halt = false;
		if (kein_halt) halt = false;
		if (halt) ok = false;
		
		return ok;
	}
	
	int nr;
	public static Signalhebel[] sh;
	public static Weichenhebel[] wh;
	public static Fahrstrasse[] fs;
	public static SpurElement[] iso;
	boolean war_belegt[];
	
	boolean eingestellt;
	int gesperrt;
	boolean festgehalten;
	boolean signal_halt;
	
	static {
		int i;
		wh = new Weichenhebel[4];
		sh = new Signalhebel[4];
		fs = new Fahrstrasse[12];
		for (i = 0; i < 12; i++) {
			fs[i] = new Fahrstrasse(i);
		}
		iso = new SpurElement[8];
	}
}
