/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

public class Signal extends SpurElement implements Runnable {
	public Signal(Lampe r, Lampe g, Lampe o, Lampe v) {
		rot = r;
		gruen = g;
		orange = o;
		vsig_stoerung = v;
	}

	public void initRoute (SpurElement l, SpurElement r, boolean lr) {
		super.initRoute (l, r, 0);
		vlnr = lr;
	}

	@Override
	public int signalStellung(boolean richtung) {
		if (richtung == vlnr) return stellung;
		if (richtung) {
			if (rechts == null) return 0;
			if (rechts.links != this) return 0;
			return rechts.signalStellung (true);
		} else {
			if (links == null) return 0;
			if (links.rechts != this) return 0;
			return links.signalStellung (false);
		}
	}
	
	@Override
	public int signalDistanz(boolean richtung, int pos) {
		if (richtung == vlnr) return 0;
		if (richtung) {
			if (rechts == null) return laenge - pos;
			return laenge + rechts.signalDistanz (true, 0);
		} else {
			if (links == null) return pos;
			return pos + links.signalDistanz (false, links.laenge);
		}
	}
	

	public void Halt () {
		if (stellung != 0 && vsig_stoerung != null) {
			vsig_stoerung.einschalten();
			new Thread(this, "Vorsignal").start();
		}
		rot.einschalten();
		gruen.ausschalten();
		orange.ausschalten();
		stellung = 0;
	}
	
	public void Fahrt () {
		rot.ausschalten();
		gruen.einschalten();
		orange.ausschalten();
		stellung = 1;
	}
	
	public void Fahrt2 () {
		rot.ausschalten();
		gruen.einschalten();
		orange.einschalten();
		stellung = 2;
	}
	
	@Override
	public void run() {
		try {
			Thread.sleep(500);
		} catch (InterruptedException e) {
			System.err.println("Interrupted Exception");
		}
		vsig_stoerung.ausschalten();
	}
	
	Lampe rot;
	Lampe orange;
	Lampe gruen;
	Lampe vsig_stoerung;
	int stellung;
	boolean vlnr;
}
